<script setup lang="ts">
import { onMounted, ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import GitApiCall from '@/api/gitApi'
import GitlabHelperApi from '@/api/gitlabHelperApi'
import HeaderTemplate from '@/components/gitlab/pipeline/common/HeaderTemplate.vue'
import JobItem from '@/components/gitlab/pipeline/common/JobItem.vue'

const props = defineProps<{ route: string }>()
const emit = defineEmits(['selected-value'])
const route = useRoute()
const store = useStore()

const canceling = ref(false)
const spinning = ref(false)
const user = ref<{ username: string; rol: string }>({ username: '', rol: '' })
const groupId = ref<string | string[]>('0')
const projectId = ref<string | string[]>('0')
const pipelineId = ref<string | string[]>('0')
const project = ref<any>({})
const pipeline = ref<any>({})
const jobsList = ref<any[]>([])
const formJobsContent = ref<any>({})
const timer = ref<number | null>(null)
const selectedValues = ref<string[]>([])
const selectedJobPreview = ref<string>('horizontal')

interface JobStatus {
  key: string
  value: string
}

const defaultJobStatus: JobStatus[] = [
  { key: 'created', value: 'Created' },
  { key: 'waiting_for_resource', value: 'Waiting for resource' },
  { key: 'preparing', value: 'Preparing' },
  { key: 'pending', value: 'Pending' },
  { key: 'running', value: 'Running' },
  { key: 'manual', value: 'Manual' },
  { key: 'success', value: 'Success' },
  { key: 'failed', value: 'Failed' },
  { key: 'scheduled', value: 'Scheduled' },
  { key: 'canceling', value: 'Canceling' },
  { key: 'canceled', value: 'Canceled' },
  { key: 'skipped', value: 'Skipped' },
]

const selectedJobStatus = ref<JobStatus[]>(
  store.state.selectedJobStatus ? store.state.selectedJobStatus : defaultJobStatus,
)

const expandedJobIds = ref<number[]>([])

const jobPreviewOptions = ref([
  { text: 'Horizontal preview', value: 'horizontal' },
  { text: 'Vertical preview', value: 'vertical' },
  { text: 'Stages preview', value: 'stages' },
])

const pipelineStatusUpdate = async () => {
  console.log('[pipelineStatusUpdate] job retry triggered, update view !!! ')
  await getPipeline()
  await getJobsList()
  statusRequest()
}

const getPipeline = async () => {
  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.getPipeline(projectId.value.toString(), pipelineId.value.toString())

    pipeline.value = response.data
    console.log('getPipeline this.pipeline:', pipeline.value)
  }
  catch (error) {
    console.error('ERROR! getPipeline error: ', error)
  }
}

const statusRequest = async () => {
  console.log('statusRequest pipeline.status: ', pipeline.value.status)

  const needUpdate = [
    'created',
    'waiting_for_resource',
    'preparing',
    'pending',
    'running',
    'manual',
    'scheduled',
  ]

  // add timer part
  if (needUpdate.includes(pipeline.value.status)) {
    // Clear existing timer if any
    if (timer.value !== null)
      clearTimeout(timer.value)

    // Set a new timer
    timer.value = setTimeout(async () => {
      console.log('Timer fired, sending request')
      await getPipeline()
      await getJobsList()
      statusRequest()
    }, 10000) as unknown as number
  }
  else {
    // Clear timer if status does not need updating
    if (timer.value !== null)
      clearTimeout(timer.value)
  }
}

const getProject = async () => {
  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.getSingleProject(projectId.value.toString())

    project.value = response.data
    console.log('getProject this.project:', project.value)
  }
  catch (error) {
    console.error('ERROR! getProject error: ', error)
  }
}

const getFormsJobsContent = async () => {
  const git = new GitApiCall()
  try {
    const response = await git.getFileContent(projectId.value.toString(), `ui%2Fforms%2Fjobs.json/raw?ref=${pipeline.value.ref}`)

    formJobsContent.value = response.data
    console.log('getFormsJobsContent this.fileContentData: ', formJobsContent.value)
  }
  catch (error) {
    formJobsContent.value = {}
    console.error('ERROR! getProjects', error)
  }
}

function getJobIcon(status: string) {
  switch (status) {
    case 'success':
      return { icon: 'tabler-circle-check', color: '#4CAF50' }
    case 'failed':
      return { icon: 'tabler-alert-circle', color: '#F44336' }
    case 'running':
      return { icon: 'tabler-loader', color: '#2196F3' }
    case 'pending':
      return { icon: 'tabler-clock', color: '#FFC107' }
    case 'canceled':
      return { icon: 'tabler-circle-x', color: '#9E9E9E' }
    case 'skipped':
      return { icon: 'tabler-circle-chevrons-right', color: '#E0E0E0' }
    case 'manual':
      return { icon: 'tabler-hand-click', color: '#9C27B0' }
    case 'created':
      return { icon: 'tabler-circle-plus', color: '#03A9F4' }
    case 'preparing':
      return { icon: 'tabler-settings', color: '#FFC107' }
    case 'scheduled':
      return { icon: 'tabler-calendar-event', color: '#00BCD4' }
    case 'waiting_for_resource':
      return { icon: 'tabler-hourglass', color: '#FFEB3B' }
    case 'failed_with_warnings':
      return { icon: 'tabler-alert-triangle', color: '#FFC107' }
    default:
      return { icon: 'tabler-circle', color: '#607D8B' }
  }
};

function reset() {
  selectedJobStatus.value = defaultJobStatus
  store.commit('setSelectedJobStatus', selectedJobStatus.value)
};

async function updatepipelineView(pipelineView: any) {
  console.log('[updatepipelineView] selected view:', pipelineView)
  emit('selected-value', pipelineView)
};

// Function to handle toggling of job expansion
function handleExpandToggle(jobId: number) {
  const index = expandedJobIds.value.indexOf(jobId) // Access the ref using .value
  if (index === -1)
    expandedJobIds.value.push(jobId) // Add jobId if not already expanded
  else
    expandedJobIds.value.splice(index, 1) // Remove jobId if already expanded
};

async function getJobsList() {
  const gitHelperApi = new GitlabHelperApi()
  try {
    const response = await gitHelperApi.getJobsList(projectId.value.toString(), pipelineId.value.toString(), [])

    jobsList.value = response.data.data
  }
  catch (error) {
    console.error('ERROR! getProjects', error)
  }
};

async function cancelPipeline() {
  canceling.value = true

  const gitApi = new GitApiCall()
  try {
    await gitApi.cancelPipeline(projectId.value.toString(), pipelineId.value.toString())
    getPipeline()
  }
  catch (error) {
    console.error('ERROR! cancelPipeline', error)
  }
  finally {
    canceling.value = false
  }
};

onMounted(async () => {
  console.log('route is : ', route)
  console.log('store is : ', store)
  user.value = store.state.user
  groupId.value = route.params.id
  projectId.value = route.params.projectId
  pipelineId.value = route.params.pipelineId
  selectedJobStatus.value = store.state.selectedJobStatus
    ? store.state.selectedJobStatus
    : [
        { key: 'created', value: 'Created' },
        { key: 'waiting_for_resource', value: 'Waiting for resource' },
        { key: 'preparing', value: 'Preparing' },
        { key: 'pending', value: 'Pending' },
        { key: 'running', value: 'Running' },
        { key: 'manual', value: 'Manual' },
        { key: 'success', value: 'Success' },
        { key: 'failed', value: 'Failed' },
        { key: 'scheduled', value: 'Scheduled' },
        { key: 'canceling', value: 'Canceling' },
        { key: 'canceled', value: 'Canceled' },
        { key: 'skipped', value: 'Skipped' },
      ]
  console.log('selectedJobStatus is : ', selectedJobStatus.value)
  selectedValues.value = selectedJobStatus.value.map(status => status.key)
  console.log('selectedValues:', selectedValues)
  await getProject()
  await getPipeline()
  getFormsJobsContent()
  getJobsList()
  statusRequest()
})

watch(selectedJobStatus, () => {
  console.log('watcher - selectedJobStatus')
  selectedValues.value = selectedJobStatus.value.map(status => status.key)
}, { deep: true })

watch(spinning, newSpinning => {
  if (newSpinning) {
    if (timer.value !== null) {
      clearInterval(timer.value)
      timer.value = null // Optionally clear the timer ref after stopping
    }
  }
  else {
    timer.value = window.setInterval(getJobsList, 60000)
  }
})
</script>

<template>
  <VCard class="mt-2">
    <HeaderTemplate
      :pipeline="pipeline"
      :group-id="groupId"
      :route="`${route}-workspace`"
      :project="project"
      :user="user"
    />

    <VCardText>
      <VRow>
        <VCol
          cols="12"
          md="3"
          class="mb-md-0 mb-2"
        >
          <VSelect
            v-model="selectedJobPreview"
            :items="jobPreviewOptions"
            item-value="value"
            item-title="text"
            label="Pipeline View"
            :menu-props="{ offsetY: true }"
            :hide-details="true"
            dense
            @update:model-value="updatepipelineView"
          />
        </VCol>
        <VCol
          cols="10"
          md="5"
          class="mb-md-0 mb-2"
        >
          <VCombobox
            v-model="selectedJobStatus"
            chips
            clearable
            multiple
            closable-chips
            clear-icon="tabler-circle-x"
            :items="defaultJobStatus"
            item-value="key"
            item-title="value"
            label="Job status filter"
          />
        </VCol>
        <VCol
          cols="2"
          md="2"
          class="pa-0 mb-md-0 mb-2"
        >
          <VBtn
            color="primary"
            variant="outlined"
            icon="tabler-filter-off"
            class="mt-4"
            size="x-small"
            @click="reset"
          />
        </VCol>
      </VRow>

      <div class="mt-5">
        <VContainer class="mb-4">
          <VRow>
            <VCol
              v-for="job in jobsList"
              v-show="selectedValues.includes(job.status)"
              :key="job.id"
              :cols="expandedJobIds.includes(job.id) ? 12 : 12"
              :sm="expandedJobIds.includes(job.id) ? 12 : 6"
              :md="expandedJobIds.includes(job.id) ? 12 : 4"
              :lg="expandedJobIds.includes(job.id) ? 12 : 3"
              :xl="expandedJobIds.includes(job.id) ? 12 : 3"
            >
              <VSheet class="pb-4">
                <VRow class="pa-0">
                  <VCol
                    cols="12"
                    class="d-flex pa-0 justify-center align-center"
                  >
                    <VIcon
                      :icon="getJobIcon(job.status).icon"
                      :color="getJobIcon(job.status).color"
                    />
                    <VDivider />
                  </VCol>
                </VRow>
                <VRow class="pa-0 pt-2 pl-5">
                  <JobItem
                    :key="job.id"
                    :job="job"
                    :project="project"
                    :group-id="groupId"
                    @expand-toggle="handleExpandToggle"
                    @retry-job="pipelineStatusUpdate"
                  />
                </VRow>
              </VSheet>
            </VCol>
          </VRow>
        </VContainer>
      </div>

      <VRow justify="end">
        <VBtn
          color="error"
          class="mt-2"
          :loading="canceling || spinning"
          :disabled="canceling || ['canceled', 'success', 'failed'].includes(pipeline.status)"
          @click="cancelPipeline"
        >
          Cancel pipeline
        </VBtn>
      </VRow>
    </VCardText>
  </VCard>
</template>

<style scoped>
.mt-5 {
  margin-top: 1.5rem;
}

.mt-2 {
  margin-top: 0.5rem;
}

.mb-1 {
  margin-bottom: 0.25rem;
}
</style>
